/// @addtogroup covrel
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file graphtset.h
///
/// @author Jaroslaw Dulak, Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _GraphicsTripleSetClass
#define _GraphicsTripleSetClass

#include "krak/krak.h"
#include "covrel/tset.h"

namespace capd{
namespace covrel{

class GraphicsTripleSet : public TripleSet
{
public:
   typedef TripleSet::FloatVector     FloatVector;
   typedef TripleSet::IntervalVector  IntervalVector;

   GraphicsTripleSet(const FloatVector& a_center, const FloatVector& a_stable, const FloatVector& a_unstable)
      : TripleSet(a_center,a_stable,a_unstable){}
   GraphicsTripleSet(const IntervalVector& a_center, const IntervalVector& a_stable, const IntervalVector& a_unstable)
      : TripleSet(a_center,a_stable,a_unstable){}
   GraphicsTripleSet(){}
   ~GraphicsTripleSet(){}

   friend Frame& operator << (Frame&, GraphicsTripleSet&);
   void show(Frame &f, const FloatVector& point, int color=BLACK) const;
   void show(Frame &f, const IntervalVector& point, int color=BLACK) const;
   void show(Frame &f) const;
}; //end of class GraphicsTripleSet

}} //namespace capd::covrel

#endif // _GraphicsTripleSetClass

/// @}
