/// @addtogroup krak
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file keys.h
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _keys_h_
#define _keys_h_

#define NO_KEY 0x1ff
#define DRAG_KEY 0x1fd
#define BUTTON_KEY 0x1fe

#if defined (WXWIN)
   enum FunctKeys{BSKey=8,TabKey,CRKey=13,PgUpKey=312,PgDnKey,EndKey,HomeKey,
                  LeftKey,UpKey,RightKey,DownKey,
                  InsKey=324,DelKey=127,EscKey=27,
                  F1Key=342,F2Key,F3Key,F4Key,F5Key,F6Key,F7Key,F8Key,F9Key,
                  DragKey=DRAG_KEY,ButtonKey=BUTTON_KEY,NoKey=NO_KEY};
#elif defined (IBM)
   enum FunctKeys{BSKey=8,TabKey,CRKey=13,PgUpKey,PgDnKey,EndKey,HomeKey,
                  LeftKey,UpKey,RightKey,DownKey,
                  InsKey,DelKey,EscKey=27,
                  F1Key=89,F2Key,F3Key,F4Key,F5Key,F6Key,F7Key,F8Key,F9Key,
                  DragKey=DRAG_KEY,ButtonKey=BUTTON_KEY,NoKey=NO_KEY};

#else
   enum FunctKeys{BSKey=65288,TabKey,CRKey=65293,PgUpKey=65365,PgDnKey,EndKey,HomeKey=65360,
                  LeftKey,UpKey,RightKey,DownKey,
                  InsKey=65379,DelKey=65535,EscKey=65307,
                  F1Key=65386,F2Key=65488,F3Key=65489,F4Key=65485,F5Key=65487,F6Key=65475,F7Key,F8Key,F9Key,
                  DragKey=DRAG_KEY,ButtonKey=BUTTON_KEY,NoKey=NO_KEY};
#endif

#endif

/// @}
