/// General function for Newton or Krawczyk method

//  f:R^n -> R^n





#ifndef _MAPPING_H_

#define _MAPPING_H_



namespace capd{

namespace newton{



template <typename MatrixType>

class Mapping{



  public:

    typedef typename MatrixType::RowVectorType VectorType;



    // value of Function

    virtual typename MatrixType::RowVectorType operator()(const VectorType & X) = 0;



    // computes derivative  of a Function

    virtual MatrixType operator[](const VectorType & X) = 0;



    // value and derivative of a Function

    virtual typename MatrixType::RowVectorType operator()(const VectorType & X, MatrixType &dF) = 0;



    virtual int getDimension() = 0;



    virtual ~Mapping() {}

};



}} //end of namespace capd::newton





#endif //_MAPPING_H_

