/// @addtogroup poincare
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file poincare.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.


#include "interval/doubleInterval.h"
#include "vectalg/dimension.h"
#include "vectalg/matrix.h"
#include "map/CnMap.h"
#include "dynsys/cntaylor.h"

#include "poincare/poincare.h"

typedef capd::map::CnMap< Matrix<double,DIM,DIM>, 3> CnMap;
typedef capd::map::CnMap< Matrix<interval,DIM,DIM>, 3> ICnMap;
typedef capd::dynsys::BasicCnTaylor<CnMap> BasicCnTaylor;
typedef capd::dynsys::CnTaylor<ICnMap> CnTaylor;

template class capd::poincare::BasicPoincareMap<BasicCnTaylor>;
template class capd::poincare::PoincareMap<CnTaylor>;

/// @}
