/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file matrixMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#include "vectalg/dimension.h"
#include "vectalg/vector.h"
#include "vectalg/matrix.h"

template class Matrix<double,0,0>;
template class RowVector<double,0>;
template class ColumnVector<double,0>;

template Matrix<double,0,0> abs <double,0,0> (const Matrix<double,0,0>&);
template Matrix<double,0,0> operator- <double,0,0> (const Matrix<double,0,0>&);
template Matrix<double,0,0> operator+ <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Matrix<double,0,0> operator- <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Matrix<double,0,0> operator* <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Vector<double,0> operator* <double,0,0> (const Matrix<double,0,0>&, const Vector<double,0>&);
template Matrix<double,0,0> operator* <double,0,0> (const Matrix<double,0,0>&, const double&);
template Matrix<double,0,0> operator* <double,0,0> (const double&, const Matrix<double,0,0>&);
template Matrix<double,0,0> operator/ <double,0,0> (const Matrix<double,0,0>&, const double&);
template Matrix<double,0,0> operator+ <double,0,0> (const Matrix<double,0,0>&, const double&);
template Matrix<double,0,0> operator- <double,0,0> (const Matrix<double,0,0>&, const double&);
template bool operator< <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template bool operator> <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template bool operator<= <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template bool operator>= <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Matrix<double,0,0> Transpose <double,0,0> (const Matrix<double,0,0>&);
template std::ostream &operator<< <double,0,0> (std::ostream&, const Matrix<double,0,0>&);
template std::istream &operator>> <double,0,0> (std::istream&, Matrix<double,0,0>&);


// RowVector

template Vector<double,0> operator+<double,0>(
      const Vector<double,0>&,
      const RowVector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const RowVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const RowVector<double,0>&,
      const RowVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(
      const Vector<double,0>&,
      const RowVector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const RowVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const RowVector<double,0>&,
      const RowVector<double,0>&
   );

template double operator*<double,0>(
      const Vector<double,0>&,
      const RowVector<double,0>&
   );
template double operator*<double,0>(
      const RowVector<double,0>&,
      const Vector<double,0>&
   );
template double operator*<double,0>(
      const RowVector<double,0>&,
      const RowVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(const RowVector<double,0>&);
template Vector<double,0> operator*<double,0,0>(
      const Matrix<double,0,0>&, const RowVector<double,0>&
   );

template Vector<double,0> operator*<double,0>(const double&, const RowVector<double,0>&);
template Vector<double,0> operator*<double,0>(const RowVector<double,0>&, const double&);
template Vector<double,0> operator/<double,0>(const RowVector<double,0>&, const double&);

template std::ostream& operator<< <double,0>(std::ostream&, const RowVector<double,0>&);


// ColumnVector

template Vector<double,0> operator+<double,0>(
      const Vector<double,0>&,
      const ColumnVector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const ColumnVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const ColumnVector<double,0>&,
      const ColumnVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(
      const Vector<double,0>&,
      const ColumnVector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const ColumnVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const ColumnVector<double,0>&,
      const ColumnVector<double,0>&
   );

template double operator*<double,0>(
      const Vector<double,0>&,
      const ColumnVector<double,0>&
   );
template double operator*<double,0>(
      const ColumnVector<double,0>&,
      const Vector<double,0>&
   );
template double operator*<double,0>(
      const ColumnVector<double,0>&,
      const ColumnVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(const ColumnVector<double,0>&);
template Vector<double,0> operator*<double,0,0>(
      const Matrix<double,0,0>&,
      const ColumnVector<double,0>&
   );

template Vector<double,0> operator*<double,0>(const double&, const ColumnVector<double,0>&);
template Vector<double,0> operator*<double,0>(const ColumnVector<double,0>&, const double&);
template Vector<double,0> operator/<double,0>(const ColumnVector<double,0>&, const double&);

template std::ostream& operator<< <double,0>(std::ostream&, const ColumnVector<double,0>&);

/// @}
