/// @addtogroup setarth
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file henon.h
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _henon_h_
#define _henon_h_

#include "capd/capdlib.h"

class Henon : public DynSys{
public:
	Henon(const interval& the_a, const interval& the_b);
	intervalVector Phi(const intervalVector &iv) const;
	intervalMatrix JacPhi(const intervalVector &iv) const;
	intervalVector Remainder(const intervalVector &iv) const;
protected:
	interval a,b;
}; 

inline Henon::Henon(const interval& the_a, const interval& the_b)
{
	a=the_a;b=the_b;
}     

inline intervalVector Henon::Remainder(const intervalVector &iv) const
{
	intervalVector result;
	result.clear();
	return result;
}
#endif

/// @}
