/// @addtogroup setarth
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file kursiva.h
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _kurshi_h_
#define _kurshi_h_

#include "capd/capdlib.h"

class KurSiva : public Ode{
public:
   KurSiva(const interval& the_l, const interval& the_d);
   intervalVector f(const intervalVector &iv) const;
   intervalMatrix df(const intervalVector &iv) const;
   intervalMatrix d2f(int i,const intervalVector &iv) const;
   void set_l(const interval& the_l);
protected:
   interval l,d;
};


//inline definitions

inline KurSiva::KurSiva(const interval& the_l, const interval& the_d)
   : l(the_l),d(the_d)
{}

inline void KurSiva::set_l(const interval& the_l)
{
   l = the_l;
}

#endif

/// @}
