/// @addtogroup vecttst
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file vectMDTest.cpp
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#include <cassert>
#include <sstream>
#include "vectalg/vector.h"

int main(int argc, char* argv[]){
  try{
    Vector<int,0> v(5),w(5),z(1);
    std::istringstream s("{5,3,2},{2},{-7 , 5 }");
    s >> z;
    std::cout << " z=" << z << std::endl;
    s >> z;
    std::cout << " z=" << z << std::endl;
    s >> z;
    std::cout << " z=" << z << std::endl;
    for(int i=0;i<5;++i){
      v[i]=2*i+1;
      w[i]=10-i;
    }
    z=v;
    std::cout << " z=" << z << std::endl;
    std::cout << v+w << std::endl;
  }catch(std::exception& e){
    std::cout << "Exception caught: " << e.what() << std::endl;
  }catch(const char *c){
    std::cout << "Exception caught: " << c << std::endl;
  }catch(...){
    std::cout << "Unknown Exception caught: " << std::endl;
  }
  return 0;
}

/// @}
